searchNodes=[{"ref":"Statix.html","title":"Statix","type":"behaviour","doc":"Writer for StatsD-compatible servers. To get started with Statix, you have to create a module that calls use Statix, like this: defmodule MyApp.Statix do use Statix end This will make MyApp.Statix a Statix connection that implements the Statix behaviour. This connection can be started with the MyApp.Statix.connect/1 function (see the connect/1 callback) and a few functions can be called on it to report metrics to the StatsD-compatible server read from the configuration. Usually, connect/1 is called in your application&#39;s Application.start/2 callback: def start(_type, _args) do :ok = MyApp.Statix.connect() # ... end Configuration Statix can be configured either globally or on a per-connection basis. The global configuration will affect all Statix connections created with use Statix; it can be specified by configuring the :statix application: config :statix, prefix: &quot;sample&quot;, host: &quot;stats.tld&quot;, port: 8181 The per-connection configuration can be specified by configuring each specific connection module under the :statix application: config :statix, MyApp.Statix, port: 8123 The following is a list of all the supported options: :prefix - (binary) all metrics sent to the StatsD-compatible server through the configured Statix connection will be prefixed with the value of this option. By default this option is not present. :host - (binary) the host where the StatsD-compatible server is running. Defaults to &quot;127.0.0.1&quot;. :port - (integer) the port (on :host) where the StatsD-compatible server is running. Defaults to 8125. :tags - ([binary]) a list of global tags that will be sent with all metrics. By default this option is not present. By default, the configuration is evaluated once, at compile time. If you plan on changing the configuration at runtime, you must specify the :runtime_config option to be true when calling use Statix: defmodule MyApp.Statix do use Statix, runtime_config: true end Tags Tags are a way of adding dimensions to metrics: MyApp.Statix.gauge(&quot;memory&quot;, 1, tags: [&quot;region:east&quot;]) In the example above, the memory measurement has been tagged with region:east. Not all StatsD-compatible servers support this feature. Sampling All the callbacks from the Statix behaviour that accept options support sampling via the :sample_rate option (see also the options/0 type). MyApp.Statix.increment(&quot;page_view&quot;, 1, sample_rate: 0.5) In the example above, the UDP packet will only be sent to the server about half of the time, but the resulting value will be adjusted on the server according to the given sample rate."},{"ref":"Statix.html#c:connect/0","title":"Statix.connect/0","type":"callback","doc":"Same as connect([])."},{"ref":"Statix.html#c:connect/1","title":"Statix.connect/1","type":"callback","doc":"Opens the connection to the StatsD-compatible server. The configuration is read from the configuration for the :statix application (both globally and per connection). The given config overrides the configuration read from the application environment."},{"ref":"Statix.html#c:decrement/1","title":"Statix.decrement/1","type":"callback","doc":"Same as decrement(key, 1, [])."},{"ref":"Statix.html#c:decrement/2","title":"Statix.decrement/2","type":"callback","doc":"Same as decrement(key, value, [])."},{"ref":"Statix.html#c:decrement/3","title":"Statix.decrement/3","type":"callback","doc":"Decrements the StatsD counter identified by key by the given value. Works same as increment/3 but subtracts value instead of adding it. For this reason value should be zero or negative. Examples iex&gt; MyApp.Statix.decrement(&quot;open_connections&quot;, 1, []) :ok"},{"ref":"Statix.html#c:gauge/2","title":"Statix.gauge/2","type":"callback","doc":"Same as gauge(key, value, [])."},{"ref":"Statix.html#c:gauge/3","title":"Statix.gauge/3","type":"callback","doc":"Writes to the StatsD gauge identified by key. Examples iex&gt; MyApp.Statix.gauge(&quot;cpu_usage&quot;, 0.83, []) :ok"},{"ref":"Statix.html#c:histogram/2","title":"Statix.histogram/2","type":"callback","doc":"Same as histogram(key, value, [])."},{"ref":"Statix.html#c:histogram/3","title":"Statix.histogram/3","type":"callback","doc":"Writes value to the histogram identified by key. Not all StatsD-compatible servers support histograms. An example of a such server statsite. Examples iex&gt; MyApp.Statix.histogram(&quot;online_users&quot;, 123, []) :ok"},{"ref":"Statix.html#c:increment/1","title":"Statix.increment/1","type":"callback","doc":"Same as increment(key, 1, [])."},{"ref":"Statix.html#c:increment/2","title":"Statix.increment/2","type":"callback","doc":"Same as increment(key, value, [])."},{"ref":"Statix.html#c:increment/3","title":"Statix.increment/3","type":"callback","doc":"Increments the StatsD counter identified by key by the given value. value is supposed to be zero or positive and decrement/3 should be used for negative values. Examples iex&gt; MyApp.Statix.increment(&quot;hits&quot;, 1, []) :ok"},{"ref":"Statix.html#c:measure/2","title":"Statix.measure/2","type":"callback","doc":"Same as measure(key, [], function)."},{"ref":"Statix.html#c:measure/3","title":"Statix.measure/3","type":"callback","doc":"Measures the execution time of the given function and writes that to the StatsD timing identified by key. This function returns the value returned by function, making it suitable for easily wrapping existing code. Examples iex&gt; MyApp.Statix.measure(&quot;integer_to_string&quot;, [], fn -&gt; Integer.to_string(123) end) &quot;123&quot;"},{"ref":"Statix.html#c:set/2","title":"Statix.set/2","type":"callback","doc":"Same as set(key, value, [])."},{"ref":"Statix.html#c:set/3","title":"Statix.set/3","type":"callback","doc":"Writes the given value to the StatsD set identified by key. Examples iex&gt; MyApp.Statix.set(&quot;unique_visitors&quot;, &quot;user1&quot;, []) :ok"},{"ref":"Statix.html#c:timing/2","title":"Statix.timing/2","type":"callback","doc":"Same as timing(key, value, [])."},{"ref":"Statix.html#c:timing/3","title":"Statix.timing/3","type":"callback","doc":"Writes the given value to the StatsD timing identified by key. value is expected in milliseconds. Examples iex&gt; MyApp.Statix.timing(&quot;rendering&quot;, 12, []) :ok"},{"ref":"Statix.html#t:key/0","title":"Statix.key/0","type":"type","doc":""},{"ref":"Statix.html#t:on_send/0","title":"Statix.on_send/0","type":"type","doc":""},{"ref":"Statix.html#t:options/0","title":"Statix.options/0","type":"type","doc":""},{"ref":"readme.html","title":"Statix","type":"extras","doc":"Statix Statix is an Elixir client for StatsD-compatible servers. It is focused on speed without sacrificing simplicity, completeness, or correctness. What makes Statix the fastest library around: direct sending to the socket [1] caching of the UDP packets header usage of IO lists [1] In contrast with process-based clients, Statix has lower memory consumption and higher throughput – Statix v1.0.0 does about 876640 counter increments per flush: It is possible to measure that yourself. ```elixir for _ for _"},{"ref":"readme.html#installation","title":"Statix - Installation","type":"extras","doc":"Add Statix as a dependency to your mix.exs file: def application() do [applications: [:statix]] end defp deps() do [{:statix, &quot;&gt;= 0.0.0&quot;}] end Then run mix deps.get in your shell to fetch the dependencies."},{"ref":"readme.html#usage","title":"Statix - Usage","type":"extras","doc":"A module that uses Statix becomes a socket connection: defmodule MyApp.Statix do use Statix end Before using connection the connect/0,1 function needs to be invoked. In general, this function is called when your application starts (for example, in its start/2 callback): def start(_type, _args) do :ok = MyApp.Statix.connect() # ... end Once the Statix connection is open, its increment/1,2, decrement/1,2, gauge/2, set/2, timing/2, and measure/2 functions can be used to push metrics to the StatsD-compatible server. Sampling Sampling is supported via the :sample_rate option: MyApp.Statix.increment(&quot;page_view&quot;, 1, sample_rate: 0.5) The UDP packet will only be sent to the server about half of the time, but the resulting value will be adjusted on the server according to the given sample rate. Tags Tags are a way of adding dimensions to metrics: MyApp.Statix.gauge(&quot;memory&quot;, 1, tags: [&quot;region:east&quot;]) Configuration Statix can be configured globally with: config :statix, prefix: &quot;sample&quot;, host: &quot;stats.tld&quot;, port: 8181 and on a per connection basis as well: config :statix, MyApp.Statix, port: 8811 The defaults are: prefix: nil host: &quot;127.0.0.1&quot; port: 8125 Note: by default, configuration is evaluated once, at compile time. If you plan using other configuration at runtime, you must specify the :runtime_config option: defmodule MyApp.Statix do use Statix, runtime_config: true end"},{"ref":"readme.html#license","title":"Statix - License","type":"extras","doc":"This software is licensed under the ISC license."},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#v1-3-0","title":"Changelog - v1.3.0","type":"extras","doc":"Added the Statix.connect/1 callback to support runtime configuration. Dropped support for Elixir v1.2."},{"ref":"changelog.html#v1-2-1","title":"Changelog - v1.2.1","type":"extras","doc":"Fixed port command for OTP versions that support ancillary data sending. Fixed ArgumentError raising when port gets closed."},{"ref":"changelog.html#v1-2-0","title":"Changelog - v1.2.0","type":"extras","doc":"Added support for global tags."},{"ref":"changelog.html#v1-1-0","title":"Changelog - v1.1.0","type":"extras","doc":"Made Statix functions overridable."}]